// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Tree;
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlTreeBuilder")]
    pub struct TreeBuilder(Object<ffi::DzlTreeBuilder, ffi::DzlTreeBuilderClass>);

    match fn {
        type_ => || ffi::dzl_tree_builder_get_type(),
    }
}

impl TreeBuilder {
    pub const NONE: Option<&'static TreeBuilder> = None;

    #[doc(alias = "dzl_tree_builder_new")]
    pub fn new() -> TreeBuilder {
        assert_initialized_main_thread!();
        unsafe { from_glib_none(ffi::dzl_tree_builder_new()) }
    }
}

impl Default for TreeBuilder {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::TreeBuilder>> Sealed for T {}
}

pub trait TreeBuilderExt: IsA<TreeBuilder> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_tree_builder_get_tree")]
    #[doc(alias = "get_tree")]
    fn tree(&self) -> Option<Tree> {
        unsafe {
            from_glib_none(ffi::dzl_tree_builder_get_tree(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "added")]
    fn connect_added<F: Fn(&Self, &Tree) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn added_trampoline<P: IsA<TreeBuilder>, F: Fn(&P, &Tree) + 'static>(
            this: *mut ffi::DzlTreeBuilder,
            object: *mut ffi::DzlTree,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                TreeBuilder::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"added\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    added_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    //#[doc(alias = "build-children")]
    //fn connect_build_children<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "build-node")]
    //fn connect_build_node<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "drag-data-get")]
    //fn connect_drag_data_get<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //    Ignored p0: Gtk.SelectionData
    //}

    //#[doc(alias = "drag-data-received")]
    //fn connect_drag_data_received<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //    Ignored p1: Gdk.DragAction
    //    Ignored p2: Gtk.SelectionData
    //}

    //#[doc(alias = "drag-node-delete")]
    //fn connect_drag_node_delete<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "drag-node-received")]
    //fn connect_drag_node_received<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //    Ignored p0: Dazzle.TreeNode
    //    Ignored p2: Gdk.DragAction
    //    Ignored p3: Gtk.SelectionData
    //}

    //#[doc(alias = "node-activated")]
    //fn connect_node_activated<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-collapsed")]
    //fn connect_node_collapsed<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-draggable")]
    //fn connect_node_draggable<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-droppable")]
    //fn connect_node_droppable<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //    Ignored p0: Gtk.SelectionData
    //}

    //#[doc(alias = "node-expanded")]
    //fn connect_node_expanded<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-popup")]
    //fn connect_node_popup<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-selected")]
    //fn connect_node_selected<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    //#[doc(alias = "node-unselected")]
    //fn connect_node_unselected<Unsupported or ignored types>(&self, f: F) -> SignalHandlerId {
    //    Ignored object: Dazzle.TreeNode
    //}

    #[doc(alias = "removed")]
    fn connect_removed<F: Fn(&Self, &Tree) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn removed_trampoline<P: IsA<TreeBuilder>, F: Fn(&P, &Tree) + 'static>(
            this: *mut ffi::DzlTreeBuilder,
            object: *mut ffi::DzlTree,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(
                TreeBuilder::from_glib_borrow(this).unsafe_cast_ref(),
                &from_glib_borrow(object),
            )
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"removed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    removed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "tree")]
    fn connect_tree_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_tree_trampoline<P: IsA<TreeBuilder>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlTreeBuilder,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(TreeBuilder::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::tree\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_tree_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<TreeBuilder>> TreeBuilderExt for O {}

impl fmt::Display for TreeBuilder {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("TreeBuilder")
    }
}
